package com.chinaitop.agile;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.openfeign.EnableFeignClients;

import com.github.pagehelper.autoconfigure.PageHelperAutoConfiguration;


@EnableEurekaClient
@EnableDiscoveryClient
@EnableFeignClients
@SpringBootApplication(exclude = PageHelperAutoConfiguration.class)//配置mybatis的配置文件使用，否则报多个分页插件
@MapperScan(basePackages = {"com.chinaitop.agile.mapper"})
public class DepotAgileApplication {

	public static void main(String[] args) {
		SpringApplication.run(DepotAgileApplication.class, args);
	}
}
