package com.chinaitop.agile.controller;

import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.ObjectUtils;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.chinaitop.agile.model.DataKcglFcbgzDefault;
import com.chinaitop.agile.model.DataKcglFcbgzDefaultExample;
import com.chinaitop.agile.model.DataKcglFcbgzDefaultExample.Criteria;
import com.chinaitop.agile.service.DataKcglFcbgzDefaultService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping(value="/JkqCrkController")
@Api(value= "JkqCrkController", description = "架空期查询类")
public class JkqCrkController {

	@Resource
	private DataKcglFcbgzDefaultService fcbgzService;

	@RequestMapping(value="/getList", produces = MediaType.APPLICATION_JSON_VALUE, method = RequestMethod.GET)
	@ApiOperation(value="架空期查询", notes = "支持分页")
	@ApiImplicitParams({
		@ApiImplicitParam(name="pageNum", value = "页码", paramType = "query"),
		@ApiImplicitParam(name="pageSize", value = "每页条数", paramType = "query"),
		@ApiImplicitParam(name="direction", value="数据来源 (1入库,-1出库)", paramType="query")
	})
	public PageInfo<DataKcglFcbgzDefault> getList(Integer pageNum, Integer pageSize,HttpServletRequest request) {
		DataKcglFcbgzDefaultExample example = new DataKcglFcbgzDefaultExample();
		Criteria criteria = example.createCriteria();
		if (null != pageNum && null != pageSize) {
			PageHelper.startPage(pageNum, pageSize);
		}
		/* 单位 */
		String orgId = ObjectUtils.toString(request.getSession().getAttribute("orgId"),"");
		if (null != orgId) {
			criteria.andUnitidEqualTo(orgId.toString());
		}
		/* 数据方向 (1入库,-1出库)*/
		criteria.andDirectionEqualTo(-1);
		example.setOrderByClause(" ModifyDate DESC");
		List<DataKcglFcbgzDefault> list = null;
		try {
			list = fcbgzService.findByList(example);
		} catch (Exception e) {
			e.printStackTrace();
		}
		PageInfo<DataKcglFcbgzDefault> pageInfo = new PageInfo<DataKcglFcbgzDefault>(list);

		return pageInfo;
	}

}
