package com.chinaitop.agile.mapper;

import com.chinaitop.agile.model.DataKcglKcswDefault;
import com.chinaitop.agile.model.DataKcglKcswDefaultExample;
import com.chinaitop.agile.model.DataKcswScedule;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface DataKcglKcswDefaultMapper {
    int countByExample(DataKcglKcswDefaultExample example);

    int deleteByExample(DataKcglKcswDefaultExample example);

    int deleteByPrimaryKey(String dataid);

    int insert(DataKcglKcswDefault record);

    int insertSelective(DataKcglKcswDefault record);

    List<DataKcglKcswDefault> selectByExample(DataKcglKcswDefaultExample example);

    DataKcglKcswDefault selectByPrimaryKey(String dataid);

    int updateByExampleSelective(@Param("record") DataKcglKcswDefault record, @Param("example") DataKcglKcswDefaultExample example);

    int updateByExample(@Param("record") DataKcglKcswDefault record, @Param("example") DataKcglKcswDefaultExample example);

    int updateByPrimaryKeySelective(DataKcglKcswDefault record);

    int updateByPrimaryKey(DataKcglKcswDefault record);

    /**
     * 粮食品种柱状图
     * 
     * @param map 单位ID
     * @return
     */
    List<DataKcswScedule> countByLspz(Map<String, Object> map);

    /**
     * 粮食等级分类饼图
     * 
     * @param map 单位ID
     * @return
     */
    List<DataKcswScedule> countByDj(Map<String, Object> map);

    /**
     * 查询总库存
     * 
     * @param map
     * @return
     */
    String countByBl(Map<String, Object> map);
    
    /**
     * 分别查询油罐、粮仓、粮和油所有的储量
     * 
     * @param map
     * @return
     */
    List<Map<String, Object>> countByBlType(Map<String, Object> map);

    List<DataKcglKcswDefault> queryLKNewData(Map<String, Object> map);

    List<DataKcglKcswDefault> getHouseOrWareList(Map<String, Object> modelMap);

    List<Map<String, Object>> countByPz();

    List<Map<String, Object>> countByXz();

    List<Map<String, Object>> countByYear();

    List<Map<String, Object>> countByCity();

	List<DataKcglKcswDefault> getMassageBych(Map<String, Object> modelMap);

	List<DataKcglKcswDefault> getDateByChHwh(Map<String, Object> modelMapmodelMap);

    List<Map<String, Object>> getWheatList(Map<String, Object> map);
    
    List<Map<String, Object>> getCornList(Map<String, Object> map);
    
    List<Map<String, Object>> getSoybeanList(Map<String, Object> map);
    
    List<Map<String, Object>> getRiceList(Map<String, Object> map);
    
    List<Map<String, Object>> getCrudeOilList(Map<String, Object> map);

    /**
     * 查询验收类型和已验收数量
     * @param map
     * @return
     */
    List<Map<String, Object>> queryYYSSL(Map<String, Object> map);

    /**
     * 查询入库验收的已验收数量
     * 
     * @param map
     * @return
     */
    Map<String, Object> findNumManager(Map<String, Object> map);

    List<DataKcglKcswDefault> findListOrRcsj(Map<String, Object> map);

    List<Map<String, Object>> findCondition(Map<String, Object> map);

    /**
     * 获取不是空仓的仓房库存数据
     * @param example
     * @return
     */
    List<DataKcglKcswDefault> queryFkcfData(DataKcglKcswDefaultExample example);
}